package larissamodel2simulation.services;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.Stereotype;

public class UMLservices {
	public boolean hasStereotype(Element element, String stereotypeName) {
	    return element.getAppliedStereotype(stereotypeName) != null;
	} 

	public List<Object> getTaggedValue(Element element, String stereotypeName, String property) {
	    Stereotype stereotype = element.getAppliedStereotype(stereotypeName);
	    List<Object> result = new ArrayList<Object>();
	    if (stereotype == null) {
	    	System.out.println("Nao Achou");
	        return result;
	    }

	    Object value = element.getValue(stereotype, property);
	    if (value instanceof Collection) {
	        result.addAll((Collection)value);
	    } else {
	        result.add(value);
	    }
	    return result;
	}
	
	public Object getTaggedValue(Element element, Stereotype stereotype, String property) {
	    String result = new String();
	    if (stereotype == null) {
	        return result;
	    }
	    Object value = element.getValue(stereotype, property);
	    if (value instanceof EnumerationLiteral) {
	    	EnumerationLiteral literal=(EnumerationLiteral)value;
//	    	System.out.println("Eh Enumeration: " + property);
//	    	return (literal.getInstance() != null) ? literal.getInstance() : literal;
	        return literal.getName();
	    } else {
//	    	System.out.println("Nao eh Enumeration: " + property);
	    	result = value.toString();
	    }
	    return result;
	}
	
	public String getTaggedValuet(Element element, Stereotype stereotype, String property) {
   	    String result = new String();
        result = stereotype.getName().concat(property);
		return result;
	}		
}
